﻿Option Strict On
Imports System.Net.Http

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
''' 
Public Class TouristInfo
    Property name As String
    Property title As String
    Property description As String
    Property url As String
End Class


Public NotInheritable Class MainPage
    Inherits Page

    Const ApiKey As String = "3651eb03cc3a3e9b"
    Dim countryName As String

    Private Async Sub ComboBox1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles ComboBox1.SelectionChanged

        Dim areaName = DirectCast(ComboBox1.SelectedItem, ComboBoxItem).Content.ToString
        Select Case areaName
            Case "アジア"
                countryName = "AAS"
            Case "ビーチリゾート"
                countryName = "BCH"
            Case "ハワイ"
                countryName = "HWI"
            Case "ヨーロッパ"
                countryName = "EUR"
            Case "アメリカ"
                countryName = "DUS"
            Case "オセアニア"
                countryName = "FOC"
            Case "アフリカ・その他"
                countryName = "CAF"
        End Select

        Dim myUrl = String.Format("http://webservice.recruit.co.jp/ab-road/spot/v1/?key={0}&area={1}&count=100&format=xml", ApiKey, countryName)
        Dim myHttpClient As New HttpClient
        Dim myResult As String = Await myHttpClient.GetStringAsync(myUrl)
        myResult = myResult.Replace("<results xmlns=" & ChrW(34) & "http://webservice.recruit.co.jp/ab-road/" & ChrW(34) & ">", "<results>")
      
        Dim xmldoc As XElement = XElement.Parse(myResult)

        Dim myTouristInfo As New List(Of TouristInfo)
        For Each result In From c In xmldoc.Descendants("spot") Select c
            With myTouristInfo
                .Add(New TouristInfo With {.name = result.Element("name").Value, .title = result.Element("title").Value, .description = result.Element("description").Value, .url = result.Element("url").Value})
            End With
        Next
        GridView1.ItemsSource = myTouristInfo
        TitleTextBlock.Text = areaName & "の観光地"
    End Sub

    Private Sub GridView1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles GridView1.SelectionChanged
        Try
            myFrame.Visibility = Windows.UI.Xaml.Visibility.Visible
            ComboBox1.IsEnabled = False
            Dim myUrl As String = DirectCast(GridView1.SelectedItem, TouristInfo).url
            myFrame.Navigate(GetType(WebBrowserPage), myUrl)
        Catch
            ComboBox1.IsEnabled = True
            myFrame.Visibility = Windows.UI.Xaml.Visibility.Collapsed
        End Try
    End Sub

    Private Sub backButton_Click(sender As Object, e As RoutedEventArgs) Handles backButton.Click
        ComboBox1.IsEnabled = True
        myFrame.Visibility = Windows.UI.Xaml.Visibility.Collapsed

    End Sub
End Class
